// Quick Chat 2.01
if(Modernizr.audio.ogg || Modernizr.audio.mp3 || Modernizr.audio.wav){
    var quick_chat_audio_element = document.createElement('audio');
    if(Modernizr.audio.ogg) {
        quick_chat_audio_element.setAttribute('src', quick_chat_js_vars.quick_chat_url+"sounds/message-sound.ogg");
    } else if(Modernizr.audio.mp3){
        quick_chat_audio_element.setAttribute('src', quick_chat_js_vars.quick_chat_url+"sounds/message-sound.mp3");
    } else if(Modernizr.audio.wav){
        quick_chat_audio_element.setAttribute('src', quick_chat_js_vars.quick_chat_url+"sounds/message-sound.wav");
    }
    quick_chat_audio_element.setAttribute('preload', 'auto');
    quick_chat_audio_support = 1;
} else{
    quick_chat_audio_support = 0;
}

jQuery.quick_chat_preg_quote = function (str) {
        var specials = new RegExp("[.*+?|()\\[\\]{}\\\\]", "g");
        return str.replace(specials, "\\$&");
};

jQuery.fn.quick_chat_insert_at_caret = function (myValue) {

    return this.each(function() {

        if (document.selection) {

        this.focus();
        sel = document.selection.createRange();
        sel.text = myValue;
        this.focus();

        } else if (this.selectionStart || this.selectionStart == '0') {
            var startPos = this.selectionStart;
            var endPos = this.selectionEnd;
            var scrollTop = this.scrollTop;
            this.value = this.value.substring(0, startPos)+ myValue+ this.value.substring(endPos,this.value.length);
            this.focus();
            this.selectionStart = startPos + myValue.length;
            this.selectionEnd = startPos + myValue.length;
            this.scrollTop = scrollTop;
        } else {
            this.value += myValue;
            this.focus();
        }
    });
};

jQuery.quick_chat_stripslashes = function (str) {
        str = str.replace(/\\'/g,'\'');
        str = str.replace(/\\"/g,'"');
        str = str.replace(/\\\\/g,'\\');
        str = str.replace(/\\0/g,'\0');
        return str;
};

jQuery.quick_chat_update = function(){
    jQuery.post(quick_chat_js_vars.quick_chat_ajaxurl, {
        action: 'quick-chat-update',
        quick_chat_update: quick_chat_js_vars.quick_chat_last_timestamp,
        quick_chat_update_nonce: quick_chat_js_vars.quick_chat_update_nonce},
        function(data){
            if(data.success==1){
                updates = data.updates;
                quick_chat_js_vars.quick_chat_last_timestamp = updates[updates.length-1].unix_timestamp;
                for(i=0;updates[i]!=undefined;i++){
                    for (smilie in quick_chat_l10n_after.quick_chat_smile_array){
                        updates[i].message = updates[i].message.replace(new RegExp(jQuery.quick_chat_preg_quote(smilie), 'g'), "<img src=\""+quick_chat_js_vars.quick_chat_url+"img/smilies/"+quick_chat_l10n_after.quick_chat_smile_array[smilie]+"\" title=\""+smilie+"\"/>");
                    }
                    user_status_class = '';
                    if(updates[i].status == 0){
                        user_status_class = 'quick-chat-admin';
                    } else if(updates[i].status == 1){
                        user_status_class = 'quick-chat-loggedin';
                    } else if(updates[i].status == 2){
                        user_status_class = 'quick-chat-guest';
                    }
                    var string = "<div class=\"quick-chat-history-message-alias-container "+user_status_class+"\"><div class=\"quick-chat-history-alias\"><a href=\"\" title=\""+quick_chat_js_vars.quick_chat_reply_to_string+" "+jQuery.quick_chat_stripslashes(updates[i].alias)+"\">"+jQuery.quick_chat_stripslashes(updates[i].alias)+"</a></div><div class=\"quick-chat-history-timestring\">"+updates[i].timestring+"</div>";
                    if(quick_chat_js_vars.quick_chat_user_status == 0){
                        string += "<input class=\"quick-chat-to-delete-boxes\" type=\"checkbox\" name=\"quick-chat-to-delete[]\" value=\""+updates[i].id+"\" />";
                    }
                    string += "<div class=\"quick-chat-history-message\">"+jQuery.quick_chat_stripslashes(updates[i].message)+"</div></div>";

                    var room_notified = 0;

                    jQuery('.quick-chat-container').each(function(){
                        var chat_id = jQuery(this).children('.quick-chat-chat-id').val()
                        var room_name = quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_room_name'];
                        var username = quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_username']
                        if(room_name == updates[i].room){
                            if( !room_notified
                                &&
                                quick_chat_audio_support
                                &&
                                quick_chat_js_vars.quick_chat_audio_enable == 1
                                &&
                                username != jQuery.quick_chat_stripslashes(updates[i].alias)
                                ) {
                                quick_chat_audio_element.play();
                                room_notified = 1;
                            }
                            jQuery(this).children('.quick-chat-history-container').append(string);
                        }
                    });
                }

                jQuery('.quick-chat-history-container').each(function(){
                    jQuery(this).animate({scrollTop: jQuery(this)[0].scrollHeight}, 500);
                });
            }

            quick_chat_js_vars.quick_chat_update_nonce = data.quick_chat_update_nonce;
            jQuery.quick_chat_update()
        },
        'json'
    );
};

jQuery.quick_chat_check_username = function (username_check, username_old, roomname, chat_id, username_taken_element, username_check_element){
    if (quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_username_timeout'] != undefined)
        clearTimeout(quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_username_timeout']);

    quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_username_timeout'] = setTimeout(function(){
        jQuery.ajax({
            type: 'POST',
            url: quick_chat_js_vars.quick_chat_ajaxurl,
            data: {action: 'quick-chat-ajax-username-check', username_check: username_check, username_old: username_old, room_name: roomname, quick_chat_username_check_nonce: quick_chat_js_vars.quick_chat_username_check_nonce},
            dataType: 'json',

            success: function(data){
                quick_chat_js_vars.quick_chat_username_check_nonce = data.quick_chat_username_check_nonce;

                if(data.username_invalid == 1){
                    username_taken_element.attr('title', quick_chat_js_vars.quick_chat_username_invalid_string);
                    quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_username_invalid'] = 1;
                } else if(data.username_invalid == 0){
                    quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_username_invalid'] = 0;
                }

                if(data.username_exists == 1){
                    username_taken_element.attr('title', quick_chat_js_vars.quick_chat_username_exists_string);
                    quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_username_exists'] = 1;
                } else if(data.username_exists == 0){
                    quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_username_exists'] = 0;
                }

                if(data.username_blocked == 1){
                    username_taken_element.attr('title', quick_chat_js_vars.quick_chat_username_blocked_string);
                    quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_username_blocked'] = 1;
                } else if(data.username_blocked == 0){
                    quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_username_blocked'] = 0;
                }

                username_check_element.css('display','none');
                if(data.username_exists == 1 || data.username_blocked == 1 || data.username_invalid == 1){
                    username_taken_element.css('display','inline');
                } else{
                    username_taken_element.css('display','none');
                    quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_username'] = data.username;
                }
            },
            beforeSend: function(){
                username_taken_element.css('display','none');
                username_check_element.css('display','inline');
                quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_username_check_wait'] = 1;
            },
            complete: function(){
                quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_username_check_wait'] = 0;
            },
            error: function(){

            }
        });
        quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_username_timeout'] = undefined;
    }, 1000);
};

jQuery.quick_chat_update_users = function (){
    jQuery(".quick-chat-container").each(function(){
        var chat_id = jQuery(this).find('.quick-chat-chat-id').val();
        var userlist_position = quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_userlist_position'];
        var this_quick_chat_container = this;

        quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_users_interval'] = setInterval(function() {
            var room_name = quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_room_name'];
            var username = quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_username'];
            jQuery.ajax({
                type: 'POST',
                url: quick_chat_js_vars.quick_chat_ajaxurl,
                data: {action: 'quick-chat-update-users', to_update_room_name: room_name, to_update_user_name: username, quick_chat_update_users_nonce: quick_chat_js_vars.quick_chat_update_users_nonce},
                dataType: 'json',

                success: function(data){
                    quick_chat_js_vars.quick_chat_update_users_nonce = data.quick_chat_update_users_nonce;

                    user_list = data.quick_chat_users_list;
                    var string = "";
                    for(i=0;user_list[i]!=undefined;i++){
                        user_status_class = "";
                        if(user_list[i].status == 0){
                            user_status_class = 'quick-chat-admin';
                        } else if(user_list[i].status == 1){
                            user_status_class = 'quick-chat-loggedin';
                        } else if(user_list[i].status == 2){
                            user_status_class = 'quick-chat-guest';
                        }
                        string += "<div class=\"quick-chat-single-user "+user_status_class+"\" ><a href=\"\" title=\""+quick_chat_js_vars.quick_chat_reply_to_string+" "+jQuery.quick_chat_stripslashes(user_list[i].alias)+"\">"+jQuery.quick_chat_stripslashes(user_list[i].alias)+"</a></div>";
                        if(userlist_position == 'top' && user_list[i] !== user_list[user_list.length-1]){
                            string += ", ";
                        }
                    }

                    jQuery(this_quick_chat_container).children('.quick-chat-users-container').html(string);
                },
                error: function(){

                }
            });
        }, quick_chat_js_vars.quick_chat_timeout_refresh_users);
    });
};

jQuery(window).load(function() {
    if(jQuery('.quick-chat-history-container').length != 0){

        jQuery('.quick-chat-history-container').each(function(){
            jQuery(this).animate({scrollTop: jQuery(this)[0].scrollHeight}, 250);
        });

        jQuery.quick_chat_update_users();

        if(quick_chat_audio_support){
            jQuery("div.quick-chat-sound-link").css('display','block');
        }

        jQuery('.quick-chat-message').keypress(function(e) {
            code = e.keyCode ? e.keyCode : e.which;
            if(code.toString() == 13) {
                e.preventDefault();

                var message_text = jQuery.trim(jQuery(this).val());
                if(message_text != ''){
                    var chat_id = jQuery(this).parents('.quick-chat-container').find('.quick-chat-chat-id').val();
                    var room_name = quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_room_name'];
                    var username = quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_username'];
                    var username_exists = quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_username_exists'];
                    var username_blocked = quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_username_blocked'];
                    var username_invalid = quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_username_invalid'];
                    var username_check_wait = quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_username_check_wait'];
                    var username_timeout = quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_username_timeout'];

                    if(username_check_wait == 1 || username_timeout != undefined) {
                        alert(quick_chat_js_vars.quick_chat_username_check_wait_string);
                    } else if(username_exists == 0 && username_blocked == 0 && username_invalid == 0 &&username_check_wait == 0 && username_timeout == undefined){
                        jQuery(this).val('');
                        jQuery.post(quick_chat_js_vars.quick_chat_ajaxurl,
                                    {action: 'quick-chat-new-message',
                                    alias: username,
                                    message: message_text,
                                    room: room_name,
                                    quick_chat_new_message_nonce: quick_chat_js_vars.quick_chat_new_message_nonce},
                                    function(data) {
                                        quick_chat_js_vars.quick_chat_new_message_nonce = data.quick_chat_new_message_nonce;
                                    });
                    } else if(username_invalid == 1) {
                        alert(quick_chat_js_vars.quick_chat_username_invalid_string);
                    } else if(username_exists == 1) {
                        alert(quick_chat_js_vars.quick_chat_username_exists_string);
                    } else if(username_blocked == 1) {
                        alert(quick_chat_js_vars.quick_chat_username_blocked_string);
                    }
                }
            }
        });

        jQuery('.quick-chat-alias').keyup(function(){
            var username_check = jQuery.trim(jQuery(this).val());
            if(username_check != ''){
                var chat_id = jQuery(this).parents('.quick-chat-container').find('.quick-chat-chat-id').val();
                var username_taken_element = jQuery(this).parents('.quick-chat-container').find('.quick-chat-username-taken');
                var username_check_element = jQuery(this).parents('.quick-chat-container').find('.quick-chat-username-check');
                var roomname = quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_room_name'];
                var username_old = quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_username']
                jQuery.quick_chat_check_username(username_check, username_old, roomname, chat_id, username_taken_element, username_check_element);
            }
        });

        jQuery("div.quick-chat-smilies-container img").bind('click', function() {
            jQuery(this).fadeOut(100, function() {
                var input_textarea = jQuery(this).parents('.quick-chat-container').find('.quick-chat-message');
                input_textarea.quick_chat_insert_at_caret(jQuery(this).attr('title'));
                jQuery(this).fadeIn(100);
            });
        });

        jQuery("div.quick-chat-history-alias a, div.quick-chat-single-user a").live('click', function(e) {
            e.preventDefault();
            var input_textarea = jQuery(this).parents('.quick-chat-container').find('.quick-chat-message');
            if(jQuery.browser.msie){
                input_textarea.quick_chat_insert_at_caret('@'+jQuery(this).text()+': ');
            }else{
                jQuery(this).fadeTo(100, 0, function() {
                    input_textarea.quick_chat_insert_at_caret('@'+jQuery(this).text()+': ');
                    jQuery(this).fadeTo(100, 1);
                });
            }
        });

        jQuery("div.quick-chat-sound-link a").bind('click', function(e) {
            e.preventDefault();

            if(quick_chat_js_vars.quick_chat_audio_enable == 1){
                quick_chat_js_vars.quick_chat_audio_enable = 0;
            } else{
                quick_chat_js_vars.quick_chat_audio_enable = 1;
            }

            jQuery("div.quick-chat-sound-link a").each(function(){
                if(quick_chat_js_vars.quick_chat_audio_enable == 0){
                    jQuery(this).css('text-decoration','line-through');
                } else{
                    jQuery(this).css('text-decoration','none');
                }
            });

            jQuery.post(quick_chat_js_vars.quick_chat_ajaxurl,
                {action : 'quick-chat-ajax-audio', sound_toggle: quick_chat_js_vars.quick_chat_audio_enable, quick_chat_audio_nonce: quick_chat_js_vars.quick_chat_audio_nonce},
                function(data) {
                    quick_chat_js_vars.quick_chat_audio_nonce = data.quick_chat_audio_nonce;
                });
        });

        if(quick_chat_js_vars.quick_chat_user_status == 0){
            jQuery("div.quick-chat-delete-link a").bind('click', function(e) {
                e.preventDefault();

                var chat_id = jQuery(this).parents('.quick-chat-container').find('.quick-chat-chat-id').val()
                var to_delete_room_name = quick_chat_l10n_after['quick_chat_chat_data'][chat_id]['quick_chat_room_name'];

                var to_delete_ids = [];
                jQuery(this).parents('.quick-chat-container').find('.quick-chat-history-container input[type=checkbox]:checked').each(function(){
                    to_delete_ids.push(jQuery(this).val());
                });

                if(to_delete_ids == ""){
                    alert(quick_chat_js_vars.quick_chat_delete_what_string);
                } else{
                    jQuery.post(quick_chat_js_vars.quick_chat_ajaxurl,
                                {action: 'quick-chat-ajax-delete', to_delete_ids: to_delete_ids, to_delete_room_name: to_delete_room_name, quick_chat_delete_nonce: quick_chat_js_vars.quick_chat_delete_nonce},
                                function(data) {
                                    quick_chat_js_vars.quick_chat_delete_nonce = data.quick_chat_delete_nonce;

                                    jQuery(".quick-chat-container").each(function(){

                                        var this_chat_id = jQuery(this).children('.quick-chat-chat-id').val();
                                        var this_room_name = quick_chat_l10n_after['quick_chat_chat_data'][this_chat_id]['quick_chat_room_name'];

                                        if(this_room_name == to_delete_room_name){
                                            jQuery(this).children('.quick-chat-history-container').html(jQuery.quick_chat_stripslashes(data.quick_chat_build_history_html));
                                        }
                                    });
                                });
                }
            });

            var quick_chat_toggle = false;
            jQuery("div.quick-chat-select-all-link a").bind('click', function(e){
                e.preventDefault();

                jQuery(this).parents('.quick-chat-container').find('.quick-chat-history-container input[type=checkbox]').attr('checked',!quick_chat_toggle);
                quick_chat_toggle = !quick_chat_toggle;
            });
        }

        jQuery.quick_chat_update();
    }
});