<?php
/*
Plugin Name: Quick Chat
Plugin URI: http://www.techytalk.info/quick-chat
Description: Quick Chat is quick and elegant WordPress chat plugin. Quick Chat supports chat rooms, in-post embedding, custom bad words filtering, emoticons, translation and css customization.
Author: Marko Martinović
Version: 2.01
Author URI: http://www.techytalk.info
License: GPL2

Copyright 2011.  Marko Martinović  (email : marko AT techytalk.info)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License, version 2, as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

global $default_quick_chat_db_version;
global $default_badwords_list;
global $default_disallow_usernames_list;
global $default_name;
global $default_keep_around_count;
global $default_name;
global $default_guest_num_digits;
global $default_timeout_consider_offline;
global $default_timeout_refresh_users;

global $quick_chat_options;
global $quick_chat_db_version;
global $quick_chat_url;
global $quick_chat_path;
global $quick_chat_is_embedded;
global $quick_chat_audio_enable;
global $quick_chat_smile_array;
global $quick_chat_chat_data_array;
global $quick_chat_last_timestamp;
global $quick_chat_is_on_page;
global $quick_chat_user_ip;
global $quick_chat_user_status;
global $quick_chat_ip_blocked;
global $quick_chat_user_name;

global $quick_chat_date_format;
global $quick_chat_time_format;
global $quick_chat_gmt_offset;

$default_badwords_list = '4r5e, 5h1t, 5hit, a55, anal, ar5e, arrse, arse, ass, ass-fucker, assfucker, assfukka, asshole, asswhole, b!tch, b00bs, b17ch, b1tch, ballbag, balls, ballsack, bastard, beastiality, bi+ch, bitch, bloody, blowjob, boiolas, boobs, booobs, boooobs, booooobs, booooooobs, breasts, buceta, bunny fucker, buttmuch, c0ck, c0cksucker, cawk, chink, cipa, cl1t, clit, clit, clits, cnut, cock, cock-sucker, cockface, cockhead, cockmunch, cockmuncher, cocksucker, cocksuka, cocksukka, cok, cokmuncher, coksucka, cox, cum, cunt, cyalis, d1ck, dick, dickhead, dildo, dirsa, dlck, dog-fucker, doggin, dogging, donkeyribber, doosh, duche, ejakulate, f u c k e r, f4nny, fag, faggitt, faggot, fanny, fannyflaps, fannyfucker, fanyy, fatass, fcuk, fcuker, fcuking, feck, fecker, fook, fooker, fuck, fuck, fucka, fucker, fuckhead, fuckin, fucking, fuckingshitmotherfucker, fuckwhit, fuckwit, fuk, fuker, fukker, fukkin, fukwhit, fukwit, fux, fux0r, gaylord, goatse, heshe, hoare, hoer, hore, jackoff, jism, kawk, knob, knobead, knobed, knobhead, knobjocky, knobjokey, l3i+ch, l3itch, m0f0, m0fo, m45terbate, ma5terb8, ma5terbate, master-bate, masterb8, masterbat, masterbat3, masterbation, masterbations, masturbate, mo-fo, mof0, mofo, motherfucker, motherfuckka, mutha, muthafecker, muthafuckker, muther, mutherfucker, n1gga, n1gger, nazi, nigg3r, nigg4h, nigga, niggah, niggas, niggaz, nigger, nob, nob jokey, nobhead, nobjocky, nobjokey, numbnuts, nutsack, p0rn, pawn, penis, penisfucker, phuck, pigfucker, pimpis, piss, pissflaps, porn, prick, pron, pusse, pussi, pussy, rimjaw, rimming, s.o.b., schlong, scroat, scrote, scrotum, sh!+, sh!t, sh1t, shag, shagger, shaggin, shagging, shemale, shi+, shit, shit, shitdick, shite, shited, shitey, shitfuck, shithead, shitter, slut, smut, snatch, spac, t1tt1e5, t1tties, teets, teez, testical, testicle, titfuck, tits, titt, tittie5, tittiefucker, titties, tittyfuck, tittywank, titwank, tw4t, twat, twathead, twatty, twunt, twunter, v14gra, v1gra, viagra, w00se, wang, wank, wanker, wanky, whoar, whore, willies, willy, vagina';
$default_ip_blocklist = '';
$default_disallow_usernames_list = 'admin, moderator';
$default_name = __('Guest_','quick-chat');
$default_keep_around_count = '0';
$default_guest_num_digits = '3';
$default_quick_chat_db_version = '12';
$default_timeout_consider_offline = '60';
$default_timeout_refresh_users = '15';

$quick_chat_date_format = get_option('date_format');
$quick_chat_time_format = get_option('time_format');
$quick_chat_gmt_offset = get_option('gmt_offset');
$quick_chat_options = get_option('quick_chat_options');
$quick_chat_db_version = get_option('quick_chat_db_version');
$quick_chat_url = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__));
$quick_chat_path = WP_PLUGIN_DIR.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__));
$quick_chat_chat_data_array = array();
$quick_chat_is_embedded = 0;
$quick_chat_user_ip = (isset($_SERVER['HTTP_X_FORWARD_FOR'])) ? $_SERVER['HTTP_X_FORWARD_FOR'] : $_SERVER['REMOTE_ADDR'];

if (isset($_COOKIE['quick_chat_sound_state'])){
    $quick_chat_audio_enable = $_COOKIE['quick_chat_sound_state'];
}else{
    $quick_chat_audio_enable = (isset($quick_chat_options['message_sound_default_on'])) ? 1 : 0;
}

function quick_chat_get_version() {
    $plugin_data = get_plugin_data( __FILE__ );
    $plugin_version = $plugin_data['Version'];
    return $plugin_version;
}

function quick_chat_init(){
    global $wpdb;
    global $quick_chat_user_status;
    global $quick_chat_ip_blocked;
    global $quick_chat_options;
    global $quick_chat_user_ip;
    $quick_chat_users_table_name = $wpdb->prefix . 'quick_chat_users';

    $plugin_path = dirname(plugin_basename(__FILE__));
    load_plugin_textdomain( 'quick-chat', false, $plugin_path.'/languages/' );
    
    global $quick_chat_user_name;
    if(current_user_can('manage_options')){
        $quick_chat_user_status = 0;

        if(isset($_COOKIE['quick_chat_admin_alias'])){
            $quick_chat_user_name = stripslashes($_COOKIE['quick_chat_admin_alias']);
        } else{
            global $user_login;
            get_currentuserinfo();
            setcookie("quick_chat_admin_alias",$user_login, 0, COOKIEPATH, COOKIE_DOMAIN, false, true);
            $quick_chat_user_name =  $user_login;
        }
    }else if(is_user_logged_in()){
        $quick_chat_user_status = 1;

        if(isset($_COOKIE['quick_chat_loggedin_alias'])){
            $quick_chat_user_name =  stripslashes($_COOKIE['quick_chat_loggedin_alias']);
        } else{
            global $user_login;
            get_currentuserinfo();
            setcookie("quick_chat_loggedin_alias", $user_login, 0, COOKIEPATH, COOKIE_DOMAIN, false, true);
            $quick_chat_user_name =  $user_login;
        }
    } else{
        $quick_chat_user_status = 2;

        if(isset($_COOKIE['quick_chat_guest_alias'])){
            $quick_chat_user_name = stripslashes($_COOKIE['quick_chat_guest_alias']);
        } else{
            $maxNumWithNumDigits = '';
            $numDigits = $quick_chat_options['guest_num_digits'];
            for($i=0; $i<$numDigits; $i++){
                $maxNumWithNumDigits .= '9';
            }
            $quick_chat_user_name = __($quick_chat_options['default_name'],'quick-chat').mt_rand(0, $maxNumWithNumDigits);
            setcookie("quick_chat_guest_alias", $quick_chat_user_name, 0, COOKIEPATH, COOKIE_DOMAIN, false, true);
        }
    }

    $quick_chat_ip_blocked = 0;
    if(isset($quick_chat_options['ip_blocklist']) && ($quick_chat_options['ip_blocklist'] && $quick_chat_user_status != 0)){
        $blocked_ips = explode(',', $quick_chat_options['ip_blocklist']);
        foreach ($blocked_ips as $blocked_ip) {
            if(strcasecmp($quick_chat_user_ip, trim($blocked_ip)) == 0){
                $quick_chat_ip_blocked = 1;
                break;
            }
        }
    }
}
add_action('init','quick_chat_init');

function quick_chat_load_stylesheet() {
    global $quick_chat_url;
    global $quick_chat_path;

    $my_style_url = $quick_chat_url . 'css/quick-chat.css';
    $my_style_file = $quick_chat_path . 'css/quick-chat.css';

    if (file_exists($my_style_file)) {
        wp_register_style('my_style_sheet', $my_style_url);
        wp_enqueue_style('my_style_sheet');
    }
}
add_action('wp_print_styles', 'quick_chat_load_stylesheet');

$quick_chat_smile_array = array(
               ':)' => 'smile.png',
		':(' => 'sad.png',
		';)' => 'wink.png',
		':P' =>'razz.png',
		':D' =>'grin.png',
		':|' => 'plain.png',
		':O' => 'surprise.png',
		':?' => 'confused.png',
		'8)' => 'glasses.png',
		'8o' => 'eek.png',
		'B)' => 'cool.png',
		':-)' => 'smile-big.png',
		':-(' => 'crying.png',
		':-*' => 'kiss.png',
		'O:-D' => 'angel.png',
		'&gt;:-D' => 'devilish.png',
		':o)' => 'monkey.png',
		':idea:' =>'idea.png',
		':important:' => 'important.png',
		':help:' => 'help.png',
		':error:' => 'error.png',
		':warning:' => 'warning.png',
		':favorite:' => 'favorite.png'
                );

class Filter_String {
    public $text = '';
    public $bad_words = array();
    public $replace_inside_bad_words = true;
    public $keep_first_last = false;

    public function filter(){
        if($this->text != ''){
            if(!empty($this->bad_words)){
                $this->text = $this->do_filter($this->text, $this->bad_words, $this->keep_first_last, $this->replace_inside_bad_words);
            }
        }
        return $this->text;
    }

    private function do_filter($text, $strings, $keep_first_last, $replace_inside_words){
            foreach($strings as $word){
                $word = trim($word);

                $replacement = '';

                $str = strlen($word);

                $first = ($keep_first_last) ? $word[0] : '';
                $str = ($keep_first_last) ? $str - 2 : $str;
                $last = ($keep_first_last) ? $word[strlen($word) - 1] : '';

                $replacement = str_repeat('*', $str);

                if($replace_inside_words){

                    if($this->keep_first_last){
                        $text = str_replace($word, $first.$replacement.$last, $text);

                        $text = str_replace(ucfirst($word), strtoupper($first).$replacement.$last, $text);
                    } else{
                        $text = str_ireplace($word, $first.$replacement.$last, $text);
                    }
                }
                else{
                    if($this->keep_first_last){
                        $text = preg_replace('/\b'.$word.'\b/', $first.$replacement.$last, $text);

                        $text = preg_replace('/\b'.ucfirst($word).'\b/', strtoupper($first).$replacement.$last, $text);
                    } else{
                        $text = preg_replace('/\b'.$word.'\b/i', $first.$replacement.$last, $text);
                    }
                }
            }
        return $text;
    }
}

function quick_chat_install() {
    global $wpdb;
    global $default_badwords_list;
    global $default_disallow_usernames_list;
    global $default_quick_chat_db_version;
    global $default_name;
    global $default_keep_around_count;
    global $default_guest_num_digits;
    global $quick_chat_options;
    global $quick_chat_db_version;
    global $default_ip_blocklist;
    global $default_timeout_consider_offline;
    global $default_timeout_refresh_users;

    $quick_chat_messages_table_name = $wpdb->prefix . 'quick_chat_messages';
    $quick_chat_users_table_name = $wpdb->prefix . 'quick_chat_users';

    // Quick Chat cannot be upgraded from 1.x to 2.x
    if($quick_chat_db_version < 12){
        $quick_chat_messages_uninstall_table_name = $wpdb->prefix . 'quick_chat';

        if(get_option('quick_chat_options')) delete_option('quick_chat_options');
        if(get_option('quick_chat_db_version')) delete_option('quick_chat_db_version');
        if(get_option('widget_quick-chat-widget')) delete_option('widget_quick-chat-widget');
        $quick_chat_options = get_option('quick_chat_options');
        $query = $wpdb->query('DROP TABLE IF EXISTS '.$quick_chat_messages_uninstall_table_name.';');
    }

    $messages_table_exists = ($wpdb->get_var('SHOW TABLES LIKE \''.$quick_chat_messages_table_name.'\';') == $quick_chat_messages_table_name) ? 1: 0;
    $users_table_exists = ($wpdb->get_var('SHOW TABLES LIKE \''.$quick_chat_users_table_name.'\';') == $quick_chat_users_table_name) ? 1: 0;

    if($messages_table_exists == 0) {
       $sql_messages = 'CREATE TABLE '.$quick_chat_messages_table_name.' (
        id BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
        room VARCHAR(50) NOT NULL DEFAULT "default",
        timestamp TIMESTAMP NOT NULL,
        alias VARCHAR(100) NOT NULL  default "",
        status TINYINT(1) NOT NULL DEFAULT 2,
        ip VARCHAR(39) NOT NULL,
        message TEXT NOT NULL,
        INDEX (timestamp DESC),
        INDEX ( room ASC)) ENGINE=MyISAM DEFAULT CHARACTER SET utf8, COLLATE utf8_general_ci;';

        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
        dbDelta($sql_messages);

   } else{
       // Future upgrades
   }

    if($users_table_exists == 0) {
        $sql_users = 'CREATE TABLE '.$quick_chat_users_table_name.' (
	status TINYINT(1) NOT NULL DEFAULT 2,
	room VARCHAR(50) NOT NULL DEFAULT "default",
	timestamp_polled TIMESTAMP NOT NULL,
        timestamp_joined TIMESTAMP NOT NULL,
	alias VARCHAR(255) NOT NULL default "",
	ip VARCHAR(39) NOT NULL default "" ,
	INDEX (timestamp_polled DESC, timestamp_joined ASC),
        UNIQUE KEY id (room, alias)) ENGINE=MyISAM DEFAULT CHARACTER SET utf8, COLLATE utf8_general_ci;';

        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
        dbDelta($sql_users);

    } else{
        // Future upgrades
    }

    if(!isset($quick_chat_options['allow_logged_in_choice'])) {
        $quick_chat_options['allow_logged_in_choice'] = '1';
    }

    if(!isset($quick_chat_options['allow_guests_choice'])) {
        $quick_chat_options['allow_guests_choice'] = '1';
    }

    if(!isset($quick_chat_options['hyperlinks'])) {
        $quick_chat_options['hyperlinks'] = '1';
    }

    if(!isset($quick_chat_options['disallow_logged_in_usernames'])) {
        $quick_chat_options['disallow_logged_in_usernames'] = '1';
    }

    if(!isset($quick_chat_options['timeout_consider_offline'])) {
        $quick_chat_options['timeout_consider_offline'] = $default_timeout_consider_offline;
    }

    if(!isset($quick_chat_options['timeout_refresh_users'])) {
        $quick_chat_options['timeout_refresh_users'] = $default_timeout_refresh_users;
    }

    if(!isset($quick_chat_options['default_name'])) {
        $quick_chat_options['default_name'] = $default_name;
    }

    if(!isset($quick_chat_options['badwords_list'])) {
        $quick_chat_options['badwords_list'] = $default_badwords_list;
    }

    if(!isset($quick_chat_options['keep_around_count'])) {
        $quick_chat_options['keep_around_count'] = $default_keep_around_count;
    }

    if(!isset($quick_chat_options['guest_num_digits'])) {
        $quick_chat_options['guest_num_digits'] = $default_guest_num_digits;
    }

    if(!isset($quick_chat_options['ip_blocklist'])) {
        $quick_chat_options['ip_blocklist'] = $default_ip_blocklist;
    }

    if(!isset($quick_chat_options['disallow_usernames_list'])) {
        $quick_chat_options['disallow_usernames_list'] = $default_disallow_usernames_list;
    }

    update_option('quick_chat_db_version', $default_quick_chat_db_version);
    update_option('quick_chat_options', $quick_chat_options);
}

function quick_chat_update_db_check() {
    global $quick_chat_db_version;
    global $default_quick_chat_db_version;

    if ($quick_chat_db_version != $default_quick_chat_db_version) {
        quick_chat_install();
    }
}
add_action('plugins_loaded', 'quick_chat_update_db_check');

function quick_chat_audio_ajax_handler(){
    check_ajax_referer('quick_chat_audio_nonce', 'quick_chat_audio_nonce');

    setcookie("quick_chat_sound_state",$_POST['sound_toggle'],0,"/");

    $response = json_encode(array('quick_chat_audio_nonce'=> wp_create_nonce('quick_chat_audio_nonce')));

    header( "Content-Type: application/json" );
    echo $response;
    exit;
}
add_action( 'wp_ajax_nopriv_quick-chat-ajax-audio', 'quick_chat_audio_ajax_handler' );
add_action( 'wp_ajax_quick-chat-ajax-audio', 'quick_chat_audio_ajax_handler' );

function quick_chat_username_check_ajax_handler(){
    global $quick_chat_options;
    global $quick_chat_user_status;
    global $user_login;
    global $wpdb;

    check_ajax_referer('quick_chat_username_check_nonce', 'quick_chat_username_check_nonce');

    $quick_chat_users_table_name = $wpdb->prefix . 'quick_chat_users';

    $username_exists = 0;
    $username_blocked = 0;
    $username_invalid = 0;

    if($_POST['username_check'] != $_POST['username_old']){
        get_currentuserinfo();
        $_POST['username_check'] = trim(stripslashes($_POST['username_check']));
        $_POST['room_name'] = trim(stripslashes($_POST['room_name']));

        if($_POST['username_check'] == '') $username_invalid = 1;
        
        if($quick_chat_user_status != 0){
            if(isset($quick_chat_options['disallow_special_usernames']) && !validate_username($_POST['username_check']) && $username_invalid == 0) $username_invalid = 1;

            global $wp_version;
            if (version_compare($wp_version, '3.1', '<')){
                require_once(ABSPATH . WPINC . '/registration.php');
            }

            if(strcasecmp($_POST['username_check'], $user_login) != 0){
                if(isset($quick_chat_options['disallow_logged_in_usernames']) && $username_invalid == 0){
                    if(username_exists($_POST['username_check']) != null){
                        $username_exists = 1;
                    }else {
                        global $wpdb;
                        $quick_chat_users_table_name = $wpdb->prefix . 'quick_chat_users';

                        $users = $wpdb->get_results('SELECT * FROM '.$quick_chat_users_table_name.' WHERE room = "'.$_POST['room_name'].'" ORDER BY alias DESC' );

                        if($users){
                            foreach($users as $u){
                                if($u->alias == $_POST['username_check']){
                                    $username_exists = 1;
                                    break;
                                }
                            }
                        }
                    }
                }

                if(isset($quick_chat_options['disallow_usernames_list']) && ($quick_chat_options['disallow_usernames_list'] != '') && $quick_chat_user_status != 0 && $username_exists == 0){
                    $blocked_usernames = explode(',', $quick_chat_options['disallow_usernames_list']);
                    foreach ($blocked_usernames as $blocked_username) {
                        if(strcasecmp($_POST['username_check'], trim($blocked_username)) == 0){
                            $username_blocked = 1;
                            break;
                        }
                    }
                }
            }
        }
    
        if($username_exists == 0 && $username_blocked == 0 && $username_invalid == 0){
            if ($quick_chat_user_status == 2){
                setcookie("quick_chat_guest_alias", $_POST['username_check'], 0, COOKIEPATH, COOKIE_DOMAIN, false, true);
            }else if($quick_chat_user_status == 1){
                setcookie("quick_chat_loggedin_alias", $_POST['username_check'], 0, COOKIEPATH, COOKIE_DOMAIN, false, true);
            }else if ($quick_chat_user_status == 0){
                setcookie("quick_chat_admin_alias",$_POST['username_check'], 0, COOKIEPATH, COOKIE_DOMAIN, false, true);
            }
            quick_chat_cleanup_users();
            quick_chat_update_users($_POST['room_name'], $_POST['username_check']);
        }
    }
    
    $response = json_encode(array('username' => $_POST['username_check'], 'username_exists'=> $username_exists , 'username_blocked'=> $username_blocked, 'username_invalid'=> $username_invalid, 'quick_chat_username_check_nonce'=> wp_create_nonce('quick_chat_username_check_nonce')));
    header( "Content-Type: application/json" );
    echo $response;
    exit;
}
add_action( 'wp_ajax_nopriv_quick-chat-ajax-username-check', 'quick_chat_username_check_ajax_handler' );
add_action( 'wp_ajax_quick-chat-ajax-username-check', 'quick_chat_username_check_ajax_handler' );

function quick_chat_delete_ajax_handler(){
    global $wpdb;
    global $quick_chat_options;
    $quick_chat_messages_table_name = $wpdb->prefix . 'quick_chat_messages';

    check_ajax_referer('quick_chat_delete_nonce', 'quick_chat_delete_nonce');

    foreach ($_POST['to_delete_ids'] as $value) {
        $wpdb->get_results('DELETE FROM '.$quick_chat_messages_table_name.' WHERE id ='.$value);
    }

    $response = json_encode(array('quick_chat_build_history_html' => quick_chat_build_history_html($_POST['to_delete_room_name']),
        'quick_chat_delete_nonce'=> wp_create_nonce('quick_chat_delete_nonce')));

    header( "Content-Type: application/json" );
    echo $response;
    exit;
}
add_action( 'wp_ajax_nopriv_quick-chat-ajax-delete', 'quick_chat_delete_ajax_handler' );
add_action( 'wp_ajax_quick-chat-ajax-delete', 'quick_chat_delete_ajax_handler' );

function quick_chat_new_message_ajax_handler(){
    global $wpdb;
    global $quick_chat_options;
    global $quick_chat_user_status;
    global $quick_chat_user_ip;

    $quick_chat_messages_table_name = $wpdb->prefix . 'quick_chat_messages';

    check_ajax_referer('quick_chat_new_message_nonce', 'quick_chat_new_message_nonce');

    $_POST['message'] = wp_kses(trim(stripslashes($_POST['message'])),'');
    $_POST['alias'] = wp_kses(trim(stripslashes($_POST['alias'])),'');
    
    if($_POST['message'] != '' && $_POST['alias'] != ''){
        if($quick_chat_user_status != 0){
            $filter = new Filter_String;

            if(isset($quick_chat_options['badwords_list']) && ($quick_chat_options['badwords_list'] != '')){
                $filter->bad_words = explode(',', $quick_chat_options['badwords_list']);
            }

            if(isset($quick_chat_options['replace_inside_bad_words'])) {
                $filter->replace_inside_bad_words = true;
            } else{
                $filter->replace_inside_bad_words = false;
            }

            if(isset($quick_chat_options['keep_first_last'])) {
                $filter->keep_first_last = true;
            } else{
                $filter->keep_first_last = false;
            }

            $filter->text = $_POST['message'];
            $_POST['message'] = $filter->filter();

            $filter->text = $_POST['alias'];
            $_POST['alias'] = $filter->filter();       
        }

        if(isset($quick_chat_options['hyperlinks'])){
            $_POST['message'] = links_add_target(make_clickable($_POST['message']));
        }    

        $rows_affected = $wpdb->query('INSERT INTO '.$quick_chat_messages_table_name.' (room, timestamp, alias, status, ip, message) VALUES ("'.$wpdb->escape($_POST['room']).'", NOW(), "'.$wpdb->escape($_POST['alias']).'", '.$quick_chat_user_status.', "'.$quick_chat_user_ip.'", "'.$wpdb->escape($_POST['message']).'");');       
    }

    $response = json_encode(array('quick_chat_new_message_nonce'=> wp_create_nonce('quick_chat_new_message_nonce')));

    header( "Content-Type: application/json" );
    echo $response;
    exit;
}
add_action( 'wp_ajax_nopriv_quick-chat-new-message', 'quick_chat_new_message_ajax_handler' );
add_action( 'wp_ajax_quick-chat-new-message', 'quick_chat_new_message_ajax_handler' );

function quick_chat_update_ajax_handler(){
    global $wpdb;
    global $quick_chat_options;
    global $quick_chat_date_format;
    global $quick_chat_time_format;
    global $quick_chat_gmt_offset;
    $quick_chat_messages_table_name = $wpdb->prefix . 'quick_chat_messages';

    check_ajax_referer('quick_chat_update_nonce', 'quick_chat_update_nonce');

    $startTime = time();
    while((time()-$startTime)<=20){
        $history = $wpdb->get_results( "    SELECT id, room, timestamp, UNIX_TIMESTAMP(timestamp) as unix_timestamp, alias, status, ip, message
                                            FROM $quick_chat_messages_table_name
                                            WHERE timestamp > FROM_UNIXTIME(".$_POST['quick_chat_update'].")
                                                ORDER BY unix_timestamp DESC" );
        if($history){
            foreach($history as $v){
                $v->timestring = date_i18n($quick_chat_date_format.' - '.$quick_chat_time_format, $v->unix_timestamp+($quick_chat_gmt_offset* 3600));
            }
            $response = json_encode(array('success'=> 1,'updates'=>$history,'quick_chat_update_nonce'=> wp_create_nonce('quick_chat_update_nonce')));

            header( "Content-Type: application/json" );
            echo $response;
            exit;
        }else{
            sleep(1);
        }
    }

    $response = json_encode(array('success'=> 0, 'quick_chat_update_nonce'=> wp_create_nonce('quick_chat_update_nonce')));

    header( "Content-Type: application/json" );
    echo $response;
    exit;
}
add_action( 'wp_ajax_nopriv_quick-chat-update', 'quick_chat_update_ajax_handler' );
add_action( 'wp_ajax_quick-chat-update', 'quick_chat_update_ajax_handler' );

function quick_chat_update_users_ajax_handler(){
    global $wpdb;
    global $quick_chat_options;
    global $quick_chat_ip_blocked;
    global $quick_chat_user_status;
    $quick_chat_messages_table_name = $wpdb->prefix . 'quick_chat_messages';

    check_ajax_referer('quick_chat_update_users_nonce', 'quick_chat_update_users_nonce');

    $_POST['to_update_user_name'] = stripslashes($_POST['to_update_user_name']);
    $_POST['to_update_room_name'] = stripslashes($_POST['to_update_room_name']);

    quick_chat_cleanup_users();

    if  (
            $quick_chat_ip_blocked == 0
            &&
            (
                (
                    isset($quick_chat_options['only_logged_in_users'])
                    &&
                    $quick_chat_user_status != 2
                )
                ||
                !isset($quick_chat_options['only_logged_in_users'])
            )
        ){
        quick_chat_update_users($_POST['to_update_room_name'], $_POST['to_update_user_name']);
    }

    $response = json_encode(array('quick_chat_users_list' => quick_chat_fetch_users($_POST['to_update_room_name']),
        'quick_chat_update_users_nonce'=> wp_create_nonce('quick_chat_update_users_nonce')));

    header( "Content-Type: application/json" );
    echo $response;
    exit;
}
add_action( 'wp_ajax_nopriv_quick-chat-update-users', 'quick_chat_update_users_ajax_handler' );
add_action( 'wp_ajax_quick-chat-update-users', 'quick_chat_update_users_ajax_handler' );

function quick_chat_js() {
    global $quick_chat_url;

    wp_enqueue_script('jquery');

    wp_enqueue_script('quick-chat-modernizr', ($quick_chat_url."js/modernizr.min.js"), array('jquery'), false, true);

    wp_enqueue_script('quick-chat', ($quick_chat_url."js/quickchat.min.js"), array('jquery','quick-chat-modernizr'), false, true);
    //wp_enqueue_script('quick-chat', ($quick_chat_url."js/quickchat.js"), array('jquery','quick-chat-modernizr'), false, true);
}
add_action('wp_head', 'quick_chat_js', 1);

function quick_chat_localize(){
    global $quick_chat_url;
    global $quick_chat_audio_enable;
    global $quick_chat_user_status;

    global $quick_chat_smile_array;
    global $quick_chat_chat_data_array;
    global $quick_chat_last_timestamp;
    global $quick_chat_user_ip;
    global $quick_chat_options;

    if($quick_chat_last_timestamp != null){
        wp_localize_script( 'quick-chat', 'quick_chat_js_vars', array   (
                                                                'quick_chat_url' => $quick_chat_url,
                                                                'quick_chat_audio_enable' => $quick_chat_audio_enable,
                                                                'quick_chat_user_status' => $quick_chat_user_status,
                                                                'quick_chat_user_ip' => $quick_chat_user_ip,
                                                                'quick_chat_delete_what_string' => __('You must select at least one message','quick-chat'),
                                                                'quick_chat_reply_to_string' => __('Reply to','quick-chat'),
                                                                'quick_chat_username_exists_string' => __('Sorry, this user name is already taken','quick-chat'),
                                                                'quick_chat_username_blocked_string' => __('Sorry, this user name is forbidden','quick-chat'),
                                                                'quick_chat_username_invalid_string' => __('Sorry, this username is invalid because it uses illegal characters','quick-chat'),
                                                                'quick_chat_ajaxurl' => admin_url('admin-ajax.php'),
                                                                'quick_chat_audio_nonce' => wp_create_nonce('quick_chat_audio_nonce'),
                                                                'quick_chat_username_check_nonce' => wp_create_nonce('quick_chat_username_check_nonce'),
                                                                'quick_chat_delete_nonce' => wp_create_nonce('quick_chat_delete_nonce'),
                                                                'quick_chat_new_message_nonce' => wp_create_nonce('quick_chat_new_message_nonce'),
                                                                'quick_chat_update_nonce' => wp_create_nonce('quick_chat_update_nonce'),
                                                                'quick_chat_update_users_nonce' => wp_create_nonce('quick_chat_update_users_nonce'),
                                                                'quick_chat_last_timestamp' => $quick_chat_last_timestamp,
                                                                'quick_chat_username_check_wait_string' => __('Please wait, user name check is in progress','quick-chat'),
                                                                'quick_chat_timeout_refresh_users' => $quick_chat_options['timeout_refresh_users'] * 1000,
                                                                'l10n_print_after' => 'quick_chat_l10n_after = ' . json_encode(array('quick_chat_smile_array' => $quick_chat_smile_array, 'quick_chat_chat_data'=> $quick_chat_chat_data_array)) . ';'
                                                            ));
    }
}
add_action('wp_print_footer_scripts', 'quick_chat_localize');

function quick_chat_init_fn(){
    register_setting('quick_chat_options', 'quick_chat_options', 'quick_chat_options_validate' );
    
    add_settings_section('donate_section', __('Donating or getting help','quick-chat'), 'section_donate_fn', __FILE__);
    add_settings_section('general_section', __('General options','quick-chat'), 'section_general_fn', __FILE__);
    add_settings_section('filter_section', __('Filter options','quick-chat'), 'section_filter_fn', __FILE__);
    add_settings_section('security_section', __('Security options','quick-chat'), 'section_security_fn', __FILE__);
    add_settings_section('appearance_section', __('Appearance options','quick-chat'), 'section_appearance_fn', __FILE__);

    add_settings_field('quick_chat_def_name', __('Chat name prefix for guest users:','quick-chat'), 'setting_defname_fn', __FILE__, 'general_section');
    add_settings_field('quick_chat_guest_num_digits', __('Maximum number of digits for random guests chat user name suffix:','quick-chat'), 'setting_guest_num_digits_fn', __FILE__, 'general_section');
    add_settings_field('quick_chat_keep_around_count', __('Keep number of messages (all rooms combined) automatically around this value (enter "0" to disable):','quick-chat'), 'setting_keep_around_count_fn', __FILE__, 'general_section');
    add_settings_field('quick_chat_message_sound_default_on', __('Incoming message sound notification on by default:','quick-chat'), 'setting_message_sound_default_on_fn', __FILE__, 'general_section');
    add_settings_field('quick_chat_timeout_consider_offline', __('Timeout after user is considered gone from chat (seconds):','quick-chat'), 'setting_timeout_consider_offline_fn', __FILE__, 'general_section');
    add_settings_field('quick_chat_timeout_refresh_users', __('Timeout for refreshing list of online users (seconds):','quick-chat'), 'setting_timeout_refresh_users_fn', __FILE__, 'general_section');

    add_settings_field('quick_chat_hyperlinks', __('Convert URLs to hyperlinks:','quick-chat'), 'setting_hyperlinks_fn', __FILE__, 'filter_section');
    add_settings_field('quick_chat_keep_first_last', __('Keep first and last letter of filtered word:','quick-chat'), 'setting_keep_first_last_fn', __FILE__, 'filter_section');
    add_settings_field('quick_chat_replace_inside_bad_words', __('Filter bad words contained inside other words:','quick-chat'), 'setting_replace_inside_bad_words_fn', __FILE__, 'filter_section');
    add_settings_field('quick_chat_disallow_special_usernames', __('Disallow using special characters inside chat user names (including special locale characters):','quick-chat'), 'setting_disallow_special_usernames_fn', __FILE__, 'filter_section');
    add_settings_field('quick_chat_bad_words', __('Bad words list (comma separated):','quick-chat'), 'setting_badwords_fn', __FILE__, 'filter_section');

    add_settings_field('quick_chat_only_logged_in_users', __('Only logged in users can use chat:','quick-chat'), 'setting_only_logged_in_users_fn', __FILE__, 'security_section');
    add_settings_field('quick_chat_allow_guests_choice', __('Allow guest users to choose their chat user names:','quick-chat'), 'setting_allow_guests_choice_fn', __FILE__, 'security_section');
    add_settings_field('quick_chat_allow_logged_in_choice', __('Allow logged in users to choose their chat user names:','quick-chat'), 'setting_allow_logged_in_choice_fn', __FILE__, 'security_section');
    add_settings_field('quick_chat_disallow_logged_in_usernames', __('Protect registered users user names from being used by other users:','quick-chat'), 'setting_disallow_logged_in_usernames_fn', __FILE__, 'security_section');
    add_settings_field('quick_chat_disallow_usernames_list', __('Restricted chat user names list (comma separated):','quick-chat'), 'setting_disallow_usernames_list_fn', __FILE__, 'security_section');
    add_settings_field('quick_chat_ip_blocklist', __('Deny chat access to the following IP addresses (comma separated):','quick-chat'), 'setting_ip_blocklist_fn', __FILE__, 'security_section');

    add_settings_field('quick_chat_hide_widget_if_embedded', __('Hide Quick Chat sidebar widget on pages where Quick Chat is embedded in post:','quick-chat'), 'setting_hide_widget_if_embedded_fn', __FILE__, 'appearance_section');
    add_settings_field('quick_chat_hide_linkhome', __('Hide "Powered by Quick Chat" link (big thanks for not hiding it):','quick-chat'), 'setting_hide_linkhome_fn', __FILE__, 'appearance_section');
    
    add_settings_field('quick_chat_paypal', __('Donate using PayPal (sincere thank you for your help):','quick-chat'), 'setting_paypal_fn', __FILE__, 'donate_section');
    add_settings_field('quick_chat_version', __('Quick Chat version:','quick-chat'), 'setting_version_fn', __FILE__, 'donate_section');
    add_settings_field('quick_chat_faq', __('Quick Chat FAQ:','quick-chat'), 'setting_faq_fn', __FILE__, 'donate_section');
    add_settings_field('quick_chat_changelog', __('Quick Chat changelog:','quick-chat'), 'setting_changelog_fn', __FILE__, 'donate_section');
    add_settings_field('quick_chat_support_page', __('Quick Chat support page:','quick-chat'), 'setting_support_page_fn', __FILE__, 'donate_section');    
}
add_action('admin_init', 'quick_chat_init_fn' );

function quick_chat_add_page_fn() {
    add_options_page('Quick Chat '.__('options page','quick-chat'), 'Quick Chat ', 'administrator', __FILE__, 'options_page_fn');
}
add_action('admin_menu', 'quick_chat_add_page_fn');

function section_donate_fn() {
    echo '<p>';
    _e('If you find Quick Chat useful you can donate to help it\'s development. Also you can get help with Quick Chat:','quick-chat');
    echo '</p>';
}

function section_general_fn() {
    echo '<p>';
    _e('Here you can control all general options:','quick-chat');
    echo '</p>';
}

function section_filter_fn() {
    echo '<p>';
    _e('Here you can control Quick Chat message and chat user names filter:','quick-chat');
    echo '</p>';
}

function section_security_fn() {
    echo '<p>';
    _e('In this section you can control security options:','quick-chat');
    echo '</p>';
}

function section_appearance_fn() {
    echo '<p>';
    _e('Here are the Quick Chat appearance options:','quick-chat');
    echo '</p>';
}

function setting_timeout_consider_offline_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_timeout_consider_offline" name="quick_chat_options[timeout_consider_offline]" size="7" type="text" value="'.$quick_chat_options['timeout_consider_offline'].'" />';
}

function setting_timeout_refresh_users_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_timeout_refresh_users" name="quick_chat_options[timeout_refresh_users]" size="7" type="text" value="'.$quick_chat_options['timeout_refresh_users'].'" />';
}

function setting_faq_fn() {
    global $quick_chat_url;
    echo '<a href="http://wordpress.org/extend/plugins/quick-chat/faq/" target="_blank">'.__('FAQ','quick-chat').'</a>';
}

//setting_version_fn
function setting_version_fn() {
    global $quick_chat_url;
    echo quick_chat_get_version();
}

function setting_changelog_fn() {
    global $quick_chat_url;
    echo '<a href="http://wordpress.org/extend/plugins/quick-chat/changelog/" target="_blank">'.__('Changelog','quick-chat').'</a>';
}

function setting_support_page_fn() {
    global $quick_chat_url;
    echo '<a href="http://www.techytalk.info/quick-chat/" target="_blank">'.__('Quick Chat at TechyTalk.info','quick-chat').'</a>';
}

function setting_paypal_fn() {
    global $quick_chat_url;
    echo '<a href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=CZQW2VZNHMGGN" target="_blank"><img src="'.$quick_chat_url.'img/paypal.gif" /></a>';
}

function setting_defname_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_def_name" name="quick_chat_options[default_name]" size="14" type="text" value="'.__($quick_chat_options['default_name'],'quick-chat').'" />';
}

function setting_keep_around_count_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_keep_around_count" name="quick_chat_options[keep_around_count]" size="7" type="text" value="'.$quick_chat_options['keep_around_count'].'" />';
}


function setting_guest_num_digits_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_guest_num_digits" name="quick_chat_options[guest_num_digits]" size="7" type="text" value="'.$quick_chat_options['guest_num_digits'].'" />';
}

function setting_badwords_fn() {
    global $quick_chat_options;
    echo '<textarea id="quick_chat_bad_words" name="quick_chat_options[badwords_list]" rows="5" cols="50" type="textarea">'.$quick_chat_options['badwords_list'].'</textarea>';
}

function setting_disallow_special_usernames_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_disallow_special_usernames" name="quick_chat_options[disallow_special_usernames]" type="checkbox" value="1" ';
    if(isset($quick_chat_options['disallow_special_usernames'])) echo 'checked="checked"';
    echo '/>';
}

function setting_replace_inside_bad_words_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_replace_inside_bad_words" name="quick_chat_options[replace_inside_bad_words]" type="checkbox" value="1" ';
    if(isset($quick_chat_options['replace_inside_bad_words'])) echo 'checked="checked"';
    echo '/>';
}

function setting_hyperlinks_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_hyperlinks" name="quick_chat_options[hyperlinks]" type="checkbox" value="1" ';
    if(isset($quick_chat_options['hyperlinks'])) echo 'checked="checked"';
    echo '/>';
}

function setting_keep_first_last_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_keep_first_last" name="quick_chat_options[keep_first_last]" type="checkbox" value="1" ';
    if(isset($quick_chat_options['keep_first_last'])) echo 'checked="checked"';
    echo '/>';
}

function setting_hide_widget_if_embedded_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_hide_widget_if_embedded" name="quick_chat_options[hide_widget_if_embedded]" type="checkbox" value="1" ';
    if(isset($quick_chat_options['hide_widget_if_embedded'])) echo 'checked="checked"';
    echo '/>';
}

function setting_hide_linkhome_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_hide_linkhome" name="quick_chat_options[hide_linkhome]" type="checkbox" value="1" ';
    if(isset($quick_chat_options['hide_linkhome'])) echo 'checked="checked"';
    echo '/>';
}

function setting_allow_logged_in_choice_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_allow_logged_in_choice" name="quick_chat_options[allow_logged_in_choice]" type="checkbox" value="1" ';
    if(isset($quick_chat_options['allow_logged_in_choice'])) echo 'checked="checked"';
    echo '/>';
}

function setting_only_logged_in_users_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_only_logged_in_users" name="quick_chat_options[only_logged_in_users]" type="checkbox" value="1" ';
    if(isset($quick_chat_options['only_logged_in_users'])) echo 'checked="checked"';
    echo '/>';
}

function setting_allow_guests_choice_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_allow_guests_choice" name="quick_chat_options[allow_guests_choice]" type="checkbox" value"1" ';
    if(isset($quick_chat_options['allow_guests_choice'])) echo 'checked="checked"';
    echo '/>';
}

function setting_message_sound_default_on_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_message_sound_default_on" name="quick_chat_options[message_sound_default_on]" type="checkbox" value"1" ';
    if(isset($quick_chat_options['message_sound_default_on'])) echo 'checked="checked"';
    echo '/>';
}

function setting_disallow_logged_in_usernames_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_disallow_logged_in_usernames" name="quick_chat_options[disallow_logged_in_usernames]" type="checkbox" value"1" ';
    if(isset($quick_chat_options['disallow_logged_in_usernames'])) echo 'checked="checked"';
    echo '/>';
}

function setting_disallow_usernames_list_fn() {
    global $quick_chat_options;
    echo '<textarea id="quick_chat_disallow_usernames_list" name="quick_chat_options[disallow_usernames_list]" rows="5" cols="50" type="textarea">'.$quick_chat_options['disallow_usernames_list'].'</textarea>';
}

function setting_ip_blocklist_fn() {
    global $quick_chat_options;
    echo '<textarea id="quick_chat_ip_blocklist" name="quick_chat_options[ip_blocklist]" rows="5" cols="50" type="textarea">'.$quick_chat_options['ip_blocklist'].'</textarea>';
}

function options_page_fn() {
?>
    <div class="wrap">
        <div class="icon32" id="icon-options-general"><br></div>
        <h2>Quick Chat</h2>
        <form action="options.php" method="post">
        <?php settings_fields('quick_chat_options'); ?>
        <?php do_settings_sections(__FILE__); ?>
        <p class="submit">
                <input name="Submit" type="submit" class="button-primary" value="<?php esc_attr_e('Save Changes'); ?>" />
        </p>
        </form>
    </div>
<?php
}

function quick_chat_options_validate($input) {
    global $default_name;
    global $default_keep_around_count;
    global $default_guest_num_digits;
    global $default_timeout_consider_offline;
    global $default_timeout_refresh_users;

    if(trim($input['default_name']) == ''){
        $input['default_name'] =  $default_name;;
    } else{
        $input['default_name'] =  wp_filter_nohtml_kses(trim($input['default_name']));
    }

    if(!is_numeric($input['keep_around_count']) || $input['keep_around_count'] < 0){
        $input['keep_around_count'] =  $default_keep_around_count;
    }


    if(!is_numeric($input['timeout_refresh_users']) || $input['timeout_refresh_users'] < 0){
        $input['timeout_refresh_users'] =  $default_timeout_refresh_users;
    } else{
        $input['timeout_refresh_users'] = floor($input['timeout_refresh_users']);
    }


    if(!is_numeric($input['timeout_consider_offline']) || $input['timeout_consider_offline'] < 0){
        $input['timeout_consider_offline'] =  $default_timeout_consider_offline;
    } else{
        $input['timeout_consider_offline'] = floor($input['timeout_consider_offline']);
    }

    $input['badwords_list'] =  wp_filter_nohtml_kses(trim($input['badwords_list']));

    $input['ip_blocklist'] =  wp_filter_nohtml_kses(trim($input['ip_blocklist']));

    $input['disallow_usernames_list'] =  wp_filter_nohtml_kses(trim($input['disallow_usernames_list']));

    if(!is_numeric($input['guest_num_digits'])){
        $input['guest_num_digits'] =  $default_guest_num_digits;
    } else if($input['guest_num_digits'] < 1){
        $input['guest_num_digits'] =  '1';
    } elseif($input['guest_num_digits'] > 10){
        $input['guest_num_digits'] =  '10';
    }

    return $input;
}

function quick_chat_update_users($room, $quick_chat_user_name) {
    global $wpdb;
    global $quick_chat_user_status;
    global $quick_chat_user_ip;
    $quick_chat_users_table_name = $wpdb->prefix . 'quick_chat_users';

    $rows_affected = $wpdb->query(' INSERT INTO
                                        '.$quick_chat_users_table_name.'
                                    SET
                                        status = '.$quick_chat_user_status.',
                                        room = "'.$room.'",
                                        timestamp_polled = NOW(),
                                        timestamp_joined = NOW(),
                                        alias = "'.$wpdb->escape($quick_chat_user_name).'",
                                        ip = "'.$quick_chat_user_ip.'"
                                    ON DUPLICATE KEY UPDATE
                                        timestamp_polled = NOW();');
}

function quick_chat_cleanup_users() {
    global $wpdb;
    global $quick_chat_options;
    $quick_chat_users_table_name = $wpdb->prefix . 'quick_chat_users';

    $wpdb->get_results('DELETE FROM '.$quick_chat_users_table_name.' WHERE timestamp_polled < TIMESTAMPADD(SECOND,-'.$quick_chat_options['timeout_consider_offline'].',NOW());');
}

function quick_chat_fetch_users($room) {
    global $wpdb;
    global $quick_chat_user_status;
    $quick_chat_users_table_name = $wpdb->prefix . 'quick_chat_users';

    $users = $wpdb->get_results('SELECT status, alias FROM '.$quick_chat_users_table_name.' WHERE room = "'.$room.'" ORDER BY timestamp_joined ASC' );

    return $users;
}

function quick_chat_build_users_html($room, $height, $userlist_position) {
    ob_start();
    global $wpdb;
    global $quick_chat_user_status;

    $users = quick_chat_fetch_users($room);

    if($userlist_position == 'right')
        echo '<div class="quick-chat-users-container quick-chat-users-container-right" style="height: '.$height.'px;">';
    else if ($userlist_position == 'top')
        echo '<div class="quick-chat-users-container quick-chat-users-container-top">';
    else if ($userlist_position == 'left')
        echo '<div class="quick-chat-users-container quick-chat-users-container-left" style="height: '.$height.'px;">';

    $string_all = '';

    if($users){
        foreach($users as $u){
            $user_status_class = '';
            if($u->status == 0){
                $user_status_class = 'quick-chat-admin';
            } else if($u->status == 1){
                $user_status_class = 'quick-chat-loggedin';
            } else if($u->status == 2){
                $user_status_class = 'quick-chat-guest';
            }
            $string_all .= '<div class="quick-chat-single-user '.$user_status_class.'" ><a href="" title="'.__('Reply to','quick-chat').' '.$u->alias.'">'.$u->alias.'</a></div>';
            if ($userlist_position == 'top' && $u != end($users)){
                $string_all .= ', ';
            }
        }
        echo $string_all;
    }
    echo '</div>';
    $content =  ob_get_contents();
    ob_end_clean();
    return $content;
}

function quick_chat_build_history_html($room) {
    ob_start();
    global $wpdb;
    global $quick_chat_smile_array;
    global $quick_chat_options;
    global $quick_chat_url;
    global $quick_chat_date_format;
    global $quick_chat_time_format;
    global $quick_chat_gmt_offset;
    global $quick_chat_last_timestamp;
    global $quick_chat_user_status;
    $quick_chat_messages_table_name = $wpdb->prefix . 'quick_chat_messages';

    $stringAll = '';

    $quick_chat_last_timestamp = time();
    $history = $wpdb->get_results('SELECT id, room, timestamp, UNIX_TIMESTAMP(timestamp) as unix_timestamp, alias, status, ip, message FROM '.$quick_chat_messages_table_name.' WHERE room = "'.$room.'" ORDER BY unix_timestamp DESC' );

    if($history){
        if($quick_chat_options['keep_around_count'] != 0 && (count($history) > (intval($quick_chat_options['keep_around_count'] * 1.2)))){
            $last_id = $wpdb->get_var('SELECT max(id) FROM '.$quick_chat_messages_table_name);
            $toCleanLimit = intval($quick_chat_options['keep_around_count'] * 0.8);
            $wpdb->get_results( 'DELETE FROM '.$quick_chat_messages_table_name.' WHERE id < ( '.$last_id.' - '.$toCleanLimit.' )');

            $history = $wpdb->get_results('SELECT id, room, UNIX_TIMESTAMP(timestamp) as unix_timestamp, alias, status, ip, message FROM '.$quick_chat_messages_table_name.' WHERE room = "'.$room.'" ORDER BY unix_timestamp DESC' );
        }

        foreach($history as $v){
            foreach($quick_chat_smile_array as $smile_sign => $smile_img) $v->message = str_replace($smile_sign, '<img title="'.$smile_sign.'" src="'.$quick_chat_url.'img/smilies/'.$smile_img.'" />', $v->message);

            $user_status_class = '';
            if($v->status == 0){
                $user_status_class = 'quick-chat-admin';
            } else if($v->status == 1){
                $user_status_class = 'quick-chat-loggedin';
            } else if($v->status == 2){
                $user_status_class = 'quick-chat-guest';
            }

            $string = ' <div class="quick-chat-history-message-alias-container '.$user_status_class.'"><div class="quick-chat-history-alias"><a href="" title="'.__('Reply to','quick-chat').' '.$v->alias.'">'.$v->alias.'</a></div>';
            $string .= '<div class="quick-chat-history-timestring">'.date_i18n($quick_chat_date_format.' - '.$quick_chat_time_format,$v->unix_timestamp+($quick_chat_gmt_offset* 3600)).'</div>';
            if($quick_chat_user_status == 0){
                $string .= '<input class="quick-chat-to-delete-boxes" type="checkbox" name="quick-chat-to-delete[]" value="'.$v->id.'" />';
            }
            $string .= '<div class="quick-chat-history-message">'.$v->message.'</div></div>';

            $stringAll = $string.$stringAll;
        }
        echo $stringAll;
    }

    $content =  ob_get_contents();
    ob_end_clean();
    return $content;
}

function quick_chat_display_chat($height = 300, $room = 'default', $userlist = 1, $userlist_position = 'left') {
    ob_start();
    global $quick_chat_smile_array;
    global $quick_chat_options;
    global $quick_chat_url;
    global $wpdb;
    global $quick_chat_date_format;
    global $quick_chat_time_format;
    global $quick_chat_gmt_offset;
    global $quick_chat_audio_enable;
    global $quick_chat_chat_data_array;
    global $quick_chat_user_ip;
    global $quick_chat_user_status;
    global $quick_chat_is_on_page;
    global $quick_chat_ip_blocked;
    global $quick_chat_user_name;


    if(!isset($quick_chat_is_on_page)) $quick_cthis_quick_chat_hat_is_on_page = 1;

    $quick_chat_messages_table_name = $wpdb->prefix . 'quick_chat_messages';

    quick_chat_cleanup_users();

    if  (
            $quick_chat_ip_blocked == 0
            &&
            (
                (
                    isset($quick_chat_options['only_logged_in_users'])
                    &&
                    $quick_chat_user_status != 2
                )
                ||
                !isset($quick_chat_options['only_logged_in_users'])
            )
        ){
        quick_chat_update_users($room, $quick_chat_user_name);
    }

    $quick_chat_chat_id = wp_generate_password(12,false,false);

    echo '<div class="quick-chat-container">';
    echo '<input type="hidden" name="quick-chat-chat-id" class="quick-chat-chat-id" value="'.$quick_chat_chat_id.'" />';
    if($userlist == 1){
        echo quick_chat_build_users_html($room, $height, $userlist_position);
    }

    echo '<div class="quick-chat-history-container" style="height: '.$height.'px;">';
        echo quick_chat_build_history_html($room);
    echo '</div>';

    $quick_chat_chat_data_array[$quick_chat_chat_id] = array('quick_chat_room_name' => $room, 'quick_chat_username' => $quick_chat_user_name,  'quick_chat_username_exists' => 0, 'quick_chat_username_blocked' => 0, 'quick_chat_username_invalid' => 0, 'quick_chat_username_check_wait' => 0, 'quick_chat_userlist_position' => $userlist_position);

    echo '  <div class="quick-chat-links">
                <div style="display: none;" class="quick-chat-sound-link">
                    <a ';
                    echo ($quick_chat_audio_enable) ? 'style="text-decoration: none;"' : 'style="text-decoration: line-through;"';
                    echo ' href="">'.__('Audio','quick-chat').'
                    </a>
                </div>';
                if ($quick_chat_user_status == 0){
                    echo '  <div class="quick-chat-select-all-link">
                                <a href="">'.__('Toggle all','quick-chat').'</a>
                            </div>
                            <div class="quick-chat-delete-link">
                                <a href="">'.__('Delete','quick-chat').'</a>
                            </div>';
                }
                echo '</div>';

    if($quick_chat_ip_blocked == 1){
        echo '<div class="quick-chat-bootom-notice">'.__('Your IP address is banned from chat.','quick-chat').'</div>';
    } else{
        if(isset($quick_chat_options['only_logged_in_users'])){
            if ($quick_chat_user_status < 2){
                echo '<div class="quick-chat-alias-container">';
                echo '<input class="quick-chat-alias" type="text" autocomplete="off" maxlength="30" value="';
                if(isset($quick_chat_options['allow_logged_in_choice'])){
                        echo htmlspecialchars($quick_chat_user_name, ENT_QUOTES).'"';
                } else{
                    echo htmlspecialchars($quick_chat_user_name, ENT_QUOTES).'" readonly="readonly"';
                }
            echo ' />';
            echo '<img class="quick-chat-username-taken" style="display: none;" src="'.$quick_chat_url.'img/smilies/warning.png" />';
            echo '<img class="quick-chat-username-check" style="display: none;" src="'.$quick_chat_url.'img/loader.gif" title="'.__('Please wait, user name check is in progress','quick-chat').'" />';
            echo '</div>';

            echo '<textarea class="quick-chat-message"></textarea>';

            echo '<div class="quick-chat-smilies-container">';
            foreach($quick_chat_smile_array as $smile_sign => $smile_img) echo '<img title="'.$smile_sign.'" src="'.$quick_chat_url.'img/smilies/'.$smile_img.'" />';
            echo '</div>';

            } else{
                echo '<div class="quick-chat-bootom-notice">'.__('You must login if you want to participate in chat.','quick-chat').'</div>';
            }

        } else{
            echo '<div class="quick-chat-alias-container">';
            echo '<input class="quick-chat-alias" type="text" autocomplete="off" maxlength="30" value="';
            if($quick_chat_user_status == 2){
                if(isset($quick_chat_options['allow_guests_choice'])){
                         echo htmlspecialchars($quick_chat_user_name, ENT_QUOTES).'"';
                } else{
                    echo htmlspecialchars($quick_chat_user_name, ENT_QUOTES).'" readonly="readonly"';
                }
            } else if ($quick_chat_user_status == 1){
                if(isset($quick_chat_options['allow_logged_in_choice'])){
                        echo htmlspecialchars($quick_chat_user_name, ENT_QUOTES).'"';
                } else{
                    echo htmlspecialchars($quick_chat_user_name, ENT_QUOTES).'" readonly="readonly"';
                }
            } else if ($quick_chat_user_status == 0){
                echo htmlspecialchars($quick_chat_user_name, ENT_QUOTES).'"';
            }
            
            echo ' />';
            echo '<img class="quick-chat-username-taken" style="display: none;" src="'.$quick_chat_url.'img/smilies/warning.png" />';
            echo '<img class="quick-chat-username-check" style="display: none;" src="'.$quick_chat_url.'img/loader.gif" title="'.__('Please wait, user name check is in progress','quick-chat').'" />';
            echo '</div>';

            echo '<textarea class="quick-chat-message"></textarea>';

            echo '<div class="quick-chat-smilies-container">';
            foreach($quick_chat_smile_array as $smile_sign => $smile_img) echo '<img title="'.$smile_sign.'" src="'.$quick_chat_url.'img/smilies/'.$smile_img.'" />';
            echo '</div>';
        }
    }

    if(!isset($quick_chat_options['hide_linkhome'])){
        echo '<a class="quick-chat-linkhome" href="http://www.techytalk.info/quick-chat" target="_blank">'.__('Powered by Quick Chat','quick-chat').'</a>';
    }
    echo '</div>';

    $content =  ob_get_contents();
    ob_end_clean();
    return $content;
}

class Quick_Chat extends WP_Widget {
    public $name = 'Quick Chat';
    /* Widget control settings. */
    public $control_options = array(
       'width' => 250,
       'height' => 300,
       'id_base' => 'quick-chat-widget');

    public function __construct() {
        $widget_options = array(
          'classname' => __CLASS__,
          'description' => __('Quick Chat is quick and elegant WordPress chat plugin that does not waste your bandwidth.','quick-chat'));

        parent::__construct($this->control_options['id_base'], $this->name, $widget_options);
    }

    function form ($instance) {
        $defaults = array('title'=>'Quick Chat','widgetheight' => '310','room' => 'default','userlist' => 1, 'userlist_position' => 'Top');
        $instance = wp_parse_args( (array) $instance, $defaults );
        ?>
        <p>
        <label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title') ?>:</label>
        <input type="text" name="<?php echo $this->get_field_name('title') ?>" id="<?php echo $this->get_field_id('title') ?> " value="<?php echo $instance['title'] ?>" size="15">
        </p>

        <p>
        <label for="<?php echo $this->get_field_id('room'); ?>"><?php _e('Chat room') ?>:</label>
        <input type="text" name="<?php echo $this->get_field_name('room') ?>" id="<?php echo $this->get_field_id('room') ?> " value="<?php echo $instance['room'] ?>" size="15">
        </p>

        <p>
        <label for="<?php echo $this->get_field_id('widgetheight'); ?>"><?php _e('Message container height in pixels:','quick-chat') ?></label>
        <input type="text" name="<?php echo $this->get_field_name('widgetheight') ?>" id="<?php echo $this->get_field_id('widgetheight') ?> " value="<?php echo $instance['widgetheight'] ?>" size="5">
        </p>

        <p>
        <label for="<?php echo $this->get_field_id('userlist'); ?>"><?php _e('Include user list:','quick-chat') ?></label>
        <input id="<?php echo $this->get_field_id('userlist') ?>" name="<?php echo $this->get_field_name('userlist') ?>" type="checkbox" value="1"
        <?php if(isset($instance['userlist'])) echo 'checked="checked"' ?> />
        </p>

        <p>
        <label for="<?php echo $this->get_field_id('userlist_position'); ?>"><?php _e('User list position:','quick-chat') ?></label>
        <select id="<?php echo $this->get_field_id('userlist_position') ?>" name="<?php echo $this->get_field_name('userlist_position') ?>">
            <option <?php if(isset($instance['userlist_position']) && $instance['userlist_position'] == 'Right') echo 'selected="selected"' ?> >Right</option>
            <option <?php if(isset($instance['userlist_position']) && $instance['userlist_position'] == 'Left') echo 'selected="selected"' ?> >Left</option>
            <option <?php if(isset($instance['userlist_position']) && $instance['userlist_position'] == 'Top') echo 'selected="selected"' ?> >Top</option>
        </select>
        </p>
        <?php
    }

    function update ($new_instance, $old_instance) {
        $instance = $old_instance;

        if(is_numeric($new_instance['widgetheight'])){
            $instance['widgetheight'] = $new_instance['widgetheight'];
        }
        $instance['title'] = $new_instance['title'];

        $instance['userlist'] = $new_instance['userlist'];

        $instance['userlist_position'] = $new_instance['userlist_position'];

        if($new_instance['room'] != ''){
            $instance['room'] = $new_instance['room'];
        }
        return $instance;
    }

    function widget ($args,$instance) {
        extract($args);
        $title = $instance['title'];
        $widgetheight = $instance['widgetheight'];
        $userlist = $instance['userlist'];
        $userlist_position = strtolower($instance['userlist_position']);
        $room = $instance['room'];
        global $quick_chat_is_embedded;
        global $quick_chat_options;
        global $wp_query;

        if($quick_chat_is_embedded == 0 || !isset($quick_chat_options['hide_widget_if_embedded'])){
            echo $before_widget;
            echo $before_title.$title.$after_title;

            if($room == 'unique'){
                if(!is_home()){
                    $room = $wp_query->post->ID;
                } else{
                    $room = 'default';
                }
            }

            echo quick_chat_display_chat($widgetheight, $room, $userlist, $userlist_position);

            echo $after_widget;
        }
    }
}

function fn_load_widgets() {
  register_widget('Quick_Chat');
}
add_action('widgets_init', 'fn_load_widgets');

function quick_chat_shortcode_handler( $atts, $content=null, $code="" ) {
    extract(shortcode_atts( array(	'height' => '300',
                                        'room' => 'default',
                                        'userlist' => '1',
                                        'userlist_position' => 'left'),
                                        $atts ));
    global $quick_chat_is_embedded;

    $quick_chat_is_embedded = 1;
    $content = quick_chat_display_chat($height, $room, $userlist, $userlist_position);
    return $content;
}
add_shortcode( 'quick-chat', 'quick_chat_shortcode_handler' );

function quick_chat_uninstall() {
    global $wpdb;
    $quick_chat_messages_table_name = $wpdb->prefix . 'quick_chat_messages';
    $quick_chat_users_table_name = $wpdb->prefix . 'quick_chat_users';

    if(get_option('quick_chat_options')) delete_option('quick_chat_options');
    if(get_option('quick_chat_db_version')) delete_option('quick_chat_db_version');
    if(get_option('widget_quick-chat-widget')) delete_option('widget_quick-chat-widget');
    $query = $wpdb->query('DROP TABLE IF EXISTS '.$quick_chat_messages_table_name.';');
    $query = $wpdb->query('DROP TABLE IF EXISTS '.$quick_chat_users_table_name.';');
}
register_uninstall_hook(__FILE__, 'quick_chat_uninstall');
/* End of file quick-chat.php */
